/* interpolation.h
 * erstellt: Fre Nov 19 16:04:24 CET 1999
 * Autoren : Mirko Belickin und Joachim Wagner
 */

#ifndef __INTERPLT_H
#define __INTERPLT_H

#include <stdio.h>
#include "matrix.h"

typedef struct interpolationFunktionen interpolationFunktionen;

typedef struct interpolation {
    interpolationFunktionen *aktion;
    void *daten;
} interpolation;

struct interpolationFunktionen {
    int (* speichern)(interpolation *m, FILE *datei);      /* strukturell */
    interpolation  * (* laden)(FILE *datei, void *vater);
    int (* freigeben)(interpolation *m, void *vater);
    interpolation * (* kreieren)(void *schablone, void *vater);
    double (* funktionswert)(interpolation *m, double x);
    char * (* name)(interpolation *m);
    interpolation * (* klasse)(interpolation *m);
    /* folgende Funktionen muessen nicht fuer jede interpolation definiert werden: */
    matrix * (* imVektor)(interpolation *m, int vektor);
    double (* linkeGrenze)(interpolation *m);
    double (* rechteGrenze)(interpolation *m);
};


/* allgemeine interpolation-Funktionen (Aufruf ueber objekt->aktion->...) */

interpolation * interpolation_klasse(interpolation *m); /* liefert Art der interpolation */

/* weitere Hilfsfunktionen */

char *interpolation_kopfzeile(FILE *datei, char *interpolationtyp) ;

#define INTERPOLATION_NUR_STELLEN_BERECHNEN 64

#endif

