/* splinipl.h
 * spline-Interpolation
 * erstellt: Fre Dez  3 15:16:23 CET 1999
 * Autoren:  Mirko Belickin und Joachim Wagner
 */

#ifndef __SPLINEINTERPOLATION_H
#define __SPLINEINTERPOLATION_H

#include "namen.h"
#include "interplt.h"
#include "matrix.h"
#include <stdio.h>

typedef struct splineinterpolationsdaten {
    matrix *x;                    /* Stuetzstellen   */ 
    matrix *y;                    /* Stuetzwerte     */ 
    matrix *c;                    /* Koeffizienten   */ 
    char *name;                   /* Name der Matrix */
    int n;                        /* Anzahl Stuetzstellen */

    /* Informationen, um Daten kompakter speichern zu koennem: */
    int stuetzstellenart;        /* 0 = freie Stellen, 
                                  * 1 = aequidistante Stellen,
                                  * 2 = nach Tschebyscheff-Polynom       */
    double a,b;                  /* Intervallgrenzen  (art != 0)         */
    int abweichendes_benutzerintervall;  /* 1 = ja */
    double a_ben, b_ben;         /* Intervallgrenzen fuer Benutzer       */

    int splineart;               /* 0 = freie Splineinterpolation      
                                  * 1 = natuerliche Splineinterpolation  
                                  * 2 = periodisch Splineinterpolation   */
    double abl2links, abl2rechts; /* freie Parameter der Splines */

} splineinterpolationsdaten;


typedef struct splineinterpolationsschablone {
    char *name;                  /* Name, den die Matrix erhalten soll   */
    int stuetzstellenart;        /* 0 = freie Stellen, 
                                  * 1 = aequidistante Stellen,
                                  * 2 = nach Tschebyscheff-Polynom       */
    matrix *x;                   /* Stuetzstellen, falls art = 0         */
    double a,b;                  /* Intervallgrenzen  (art != 0)         */
    matrix *y;                   /* Stuetzwerte                          */
    int splineart;               /* 0 = freie Splineinterpolation      
                                  * 1 = natuerliche Splineinterpolation  
                                  * 2 = periodisch Splineinterpolation   */

    double abl2links;            /* Parameter der freien Splines */
    double abl2rechts;

} splineinterpolationsschablone;


#endif
